-----------------------------------------------------------
-- Colin McRay Dirt car import script for 3D STUDIO MAX  --
-- Made with 3DSMAX 9, script should work on max 8+      --
-- Textures are converted automatically if they exist in --
-- a pssg file. Does not yet convert interiors and tracks--
-- Made by vagos21. e-mail: vagos21@yahoo.com            --
-- To the memory of our hero, Ayrton Senna...            --
-- (and sadly recently, Colin McRae too)                 --
-- A million thanks to Black (Jharro) once again!        --
-----------------------------------------------------------
struct segmentstable(name,blockname,moreblockname,farr = #())
struct materialstable(fxname,materialname,numparams) --do not read constants yet
struct blockstable(name,hasVertex,hasColor,hasST1,hasST2,hasNormal,hasTangent,hasBinormal,ST1size,ST2size,VertexArr = #(),ST1Arr = #(),ST2Arr = #())

macroScript CMR_DIRT category:"myscripts"
(
	undo off
	modelpath = getOpenFileName caption:"Select a Colin McRae: Dirt file" types:"PSSG(*.pssg)|*.pssg"
	--modelpath = "C:\Documents and Settings\vangelis\Desktop\man_highLOD.pssg"
	loadMesh modelpath --load mesh
) --main script


fn loadMesh filename =
(
	f = fopen filename "rb" --open file
	fseek f 14284 #seek_set --jump header
	
	filesize = getFileSize filename
	print ("File size: "+filesize as string)

	nodesarr = #()
	segmentsarr = #()
	VBsarr = #()
	matsarr = #()

	do
	(
	if ((ftell f)>=filesize) then exit
		code134 = readBIGlong (readlong f #unsigned)
		size134 = readBIGlong (readlong f #unsigned)
		jump134 = readBIGlong (readlong f #unsigned)
		case code134 of
		(
			134:(
			code = readBIGlong (readlong f #unsigned)
			size = readBIGlong (readlong f #unsigned)
			jump = readBIGlong (readlong f #unsigned)
			case code of
			(
				196:(
					section = ""
					for w=1 to jump do (section += (bit.intasChar(readByte f #unsigned)))
					case section of
					(
						"NODE":(
							print "Reading NODES section"
							--match index and vertex buffers
							for s=1 to segmentsarr.count do--segmentsarr.count do
							(
								varr = #()
								uvwarr = #()
								for v=1 to VBsarr.count do
								(
									if  (segmentsarr[s].blockname=="#"+VBsarr[v].name) then (varr = VBsarr[v].VertexArr; if VBsarr[v].hasST1 then uvwarr = VBsarr[v].ST1Arr)
									if  (segmentsarr[s].moreblockname=="#"+VBsarr[v].name) then (uvwarr = VBsarr[v].ST1Arr)
								)
								--build mesh
								amesh = mesh vertices:varr faces:segmentsarr[s].farr name: segmentsarr[s].name
								--apply UV mapping
								applyuvw amesh uvwarr
							)
	
	print "(vertices and faces matched)"
						
							--go on and read scene from file
							fseek f 158 #seek_cur --jump scene root dummy
							do
							(
								code1 = readBIGlong (readlong f #unsigned)
								size1 = readBIGlong (readlong f #unsigned)
								jump1 = readBIGlong (readlong f #unsigned)
								if (code1 != 117) and (code1!=128) and (code1!=90) then (fseek f -12 #seek_cur; exit)
								case code1 of
								(
									117:(--DUMMY!
										fseek f 8 #seek_cur
										size = readBIGlong (readlong f #unsigned)
										--read dummy name
										dummyname = ""
										for w=1 to size do (dummyname += (bit.intasChar(readByte f #unsigned)))
										fseek f (24+size) #seek_cur
										--read transformation matrix
										transMatrix= matrix3 0
										transMatrix.row1=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										transMatrix.row2=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										transMatrix.row3=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										transMatrix.row4=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										--read the 2 points
										fseek f 12 #seek_cur
										point1 =[readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned)]
										point2 =[readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned)]
										--add dummy to nodes array
										adummy = dummy name:dummyname
										adummy.boxsize = [0.1,0.1,0.1]
										adummy.transform = transMatrix
									)--117
									128:(--MESH!
										fseek f 20 #seek_cur
										size1 = readBIGlong (readlong f #unsigned)
										--read mesh name
										meshname = ""
										for w=1 to size1 do (meshname += (bit.intasChar(readByte f #unsigned)))
										fseek f (12+size1) #seek_cur
										codez = readBIGlong (readlong f #unsigned)
										if (codez == 82) then (fseek f 16 #seek_cur; sizez= readBIGlong (readlong f #unsigned); fseek f sizez #seek_cur) else (fseek f -4 #seek_cur)
										--read transformation matrix
										fseek f 12 #seek_cur
										transMatrix= matrix3 0
										transMatrix.row1=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										transMatrix.row2=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										transMatrix.row3=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										transMatrix.row4=[readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)]
										fseek f 4 #seek_cur
										--read the 2 points
										fseek f 12 #seek_cur
										point1 =[readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned)]
										point2 =[readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned),readBIGfloat (readlong f #unsigned)]	
										do
										(
											code2 = readBIGlong (readlong f #unsigned)
											size2 = readBIGlong (readlong f #unsigned)
											jump2 = readBIGlong (readlong f #unsigned)
											if (code2!=120) then (fseek f -12 #seek_cur; exit)
											--read segment name
											fseek f 20 #seek_cur
											sizeseg = readBIGlong (readlong f #unsigned)
											segname = ""
											for w=1 to sizeseg do (segname += (bit.intasChar(readByte f #unsigned)))
											--read material name
											fseek f 20 #seek_cur
											size = readBIGlong (readlong f #unsigned)
											matname = ""
											for w=1 to size do (matname += (bit.intasChar(readByte f #unsigned)))
											--read VB name
											fseek f 8 #seek_cur
											size = readBIGlong (readlong f #unsigned)
											vbname = ""
											for w=1 to size do (vbname += (bit.intasChar(readByte f #unsigned)))
											--jump the rest of bytes
											fseek f (24+sizeseg) #seek_cur
											--get mesh from scene, transform it and apply material
											for s=1 to segmentsarr.count do
											(
												if segmentsarr[s].name==(substring segname 2 -1) then
												(
													(getNodeByName segmentsarr[s].name).transform = transMatrix
													(getNodeByName segmentsarr[s].name).name = meshname
												exit
												)
											)
										) while ((code2==120) and (ftell f<filesize))
									)--128
									90:(--???

									)
								) --code case 128 or 117
							) while (ftell f < filesize)
						) --NODE
						
						"SEGMENTSET":(
						print "Reading SEGMENTSET section"
						do(
							code1 = readBIGlong (readlong f #unsigned)
							size1 = readBIGlong (readlong f #unsigned)
							jump1 = readBIGlong (readlong f #unsigned)
							if (code1 != 165) then (fseek f -12 #seek_cur; exit)
							fseek f 20 #seek_cur
							size = readBIGlong (readlong f #unsigned)
							fseek f size #seek_cur  --jump psegmentset
							do
							(
								code2 = readBIGlong (readlong f #unsigned)
								size2 = readBIGlong (readlong f #unsigned)
								jump2 = readBIGlong (readlong f #unsigned)
								if (code2 != 116) then (fseek f -12 #seek_cur; exit)
								afarr = #()
								fseek f 20 #seek_cur
								size = readBIGlong (readlong f #unsigned)
								aname = ""
								for w=1 to size do (aname += (bit.intasChar(readByte f #unsigned)))
								fseek f 83 #seek_cur
								size = readBIGlong (readlong f #unsigned)
								fseek f size #seek_cur  --jump PRenderIndexSource
								fseek f 4 #seek_cur
								numfaces = ((readBIGlong (readlong f #unsigned))-4)/6
								fseek f 4 #seek_cur
								for k=1 to numfaces do
								(
									aaface = [readBIGshort (readshort f #unsigned) +1, readBIGshort (readshort f #unsigned) +1, readBIGshort (readshort f #unsigned) +1]
									append afarr aaface 
								)
								blockname = ""
								moreblockname = ""
								do
								(
									code3 = readBIGlong (readlong f #unsigned)
									size3 = readBIGlong (readlong f #unsigned)
									jump3 = readBIGlong (readlong f #unsigned)
									if (code3 != 112) then (fseek f -12 #seek_cur; exit)
									fseek f 8 #seek_cur
									size = readBIGlong (readlong f #unsigned)
									ablockname = ""
									for w=1 to size do (ablockname += (bit.intasChar(readByte f #unsigned)))
									fseek f 20 #seek_cur
									size = readBIGlong (readlong f #unsigned)
									fseek f size #seek_cur
									if ( (substring ablockname 1 6) == "#block" ) then
									(
										blockname = ablockname
									)
									else ( moreblockname = ablockname )
								) while (code3==112)
								asegment = segmentstable aname blockname moreblockname afarr
								append segmentsarr asegment
							) while (code2==116)
						)while (code1==165)		
						) --SEGMENTSET

						"SHADERINSTANCE":(
						print "Reading SHADERINSTANCE section"
						do
						(
							code1 = readBIGlong (readlong f #unsigned)
							size1 = readBIGlong (readlong f #unsigned)
							jump1 = readBIGlong (readlong f #unsigned)
							if (code1 != 132) then (fseek f -12 #seek_cur; exit)
							fseek f 8 #seek_cur
							size = readBIGlong (readlong f #unsigned)
							afxname = ""
							for w=1 to size do (afxname += (bit.intasChar(readByte f #unsigned)))
							fseek f 20 #seek_cur
							numparams = readBIGlong (readlong f #unsigned)
							fseek f 20 #seek_cur
							size = readBIGlong (readlong f #unsigned)
							amatname = ""
							for w=1 to size do (amatname += (bit.intasChar(readByte f #unsigned)))
							do
							(
								code2 = readBIGlong (readlong f #unsigned)
								size2 = readBIGlong (readlong f #unsigned)
								if (code2 != 149) then (fseek f -8 #seek_cur; exit)
								fseek f size2 #seek_cur --jump parameters for now!						
							) while (code2==149)
							--add material info to array
							amat = materialstable afxname amatname numparams
							append matsarr amat
						) while (code1==132)
						) --SHADERINSTANCE

						"SHADERGROUP":(
						print "Reading SHADERGROUP section"
						do
						(
							code1 = readBIGlong (readlong f #unsigned)
							size1 = readBIGlong (readlong f #unsigned)
							if (code1!=126) then (fseek f -8 #seek_cur; exit)
							fseek f size1 #seek_cur --jump shaders!
						) while (code1==126)
						) --SHADERGROUP

						"RENDERINTERFACEBOUND":(
						print "Reading RENDERINTERFACEBOUND section"
						do
						(
						code1 = readBIGlong (readlong f #unsigned)
						size1 = readBIGlong (readlong f #unsigned)
						jump1 = readBIGlong (readlong f #unsigned)						
						if (code1!=93)and(code1!=83) then (fseek f -12 #seek_cur; exit)
						case code1 of
						(
						93:
							(
							ablock = blockstable "" false false false false false false false
							stride=0
							fseek f 8 #seek_cur
							numdefs = readBIGlong (readlong f #unsigned)
							fseek f 32 #seek_cur					
							size = readBIGlong (readlong f #unsigned)
							ablockname = ""
							for w=1 to size do (ablockname += (bit.intasChar(readByte f #unsigned)))
							ablock.name = ablockname
							for def = 1 to numdefs do
							(
								fseek f 20 #seek_cur
								size = readBIGlong (readlong f #unsigned)
								deftype = ""
								for w=1 to size do (deftype += (bit.intasChar(readByte f #unsigned)))
								fseek f 8 #seek_cur
								size = readBIGlong (readlong f #unsigned)
								defsize = ""
								for w=1 to size do (defsize += (bit.intasChar(readByte f #unsigned)))
								fseek f 20 #seek_cur
								stride = readBIGlong (readlong f #unsigned)
								case deftype of
								(
									"ST": if ablock.hasST1 then (ablock.hasST2 = true; ablock.ST2size = defsize) else (ablock.hasST1 = true; ablock.ST1size = defsize)
									"Vertex": ablock.hasVertex = true
									"Color": ablock.hasColor = true
									"Normal": ablock.hasNormal = true
									"Tangent": ablock.hasTangent = true
									"Binormal": ablock.hasBinormal = true
								)
							)
							fseek f 4 #seek_cur
							length = readBIGlong (readlong f #unsigned)
							numverts = (length-4)/stride
							fseek f 4 #seek_cur
							for v = 1 to numverts do --read vertex buffer
							(
								if (ablock.hasVertex) then (append ablock.VertexArr [readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned), readBIGfloat (readlong f #unsigned)])
								if (ablock.hasST1) then
								(
								if (ablock.ST1size=="half2") then (append ablock.ST1Arr [readBIGhalf (readshort f #signed), -(readBIGhalf (readshort f #signed)), 0.0])
								if (ablock.ST1size=="float3") then (append ablock.ST1Arr [readBIGfloat (readlong f #unsigned), -(readBIGfloat (readlong f #unsigned)), readBIGfloat (readlong f #unsigned)])
								if (ablock.ST1size=="float2") then (append ablock.ST1Arr [readBIGfloat (readlong f #unsigned), -(readBIGfloat (readlong f #unsigned)), 0.0])
								)
								if (ablock.hasST2) then
								(
								if (ablock.ST2size=="half2") then (append ablock.ST2Arr [readBIGhalf (readshort f #signed), -(readBIGhalf (readshort f #signed)), 0.0])
								if (ablock.ST2size=="float3") then (append ablock.ST2Arr [readBIGfloat (readlong f #unsigned), -(readBIGfloat (readlong f #unsigned)), readBIGfloat (readlong f #unsigned)])
								if (ablock.ST2size=="float2") then (append ablock.ST2Arr [readBIGfloat (readlong f #unsigned), -(readBIGfloat (readlong f #unsigned)), 0.0])
								)
								if (ablock.hasNormal) then (fseek f 8 #seek_cur)
								if (ablock.hasColor) then (fseek f 4 #seek_cur)
								if (ablock.hasTangent) then (fseek f 8 #seek_cur)
								if (ablock.hasBinormal) then (fseek f 8 #seek_cur)								
							)
							append VBsarr ablock
							)--code 93

						83:	(
							fseek f 8 #seek_cur
							width = readBIGlong (readlong f #unsigned)
							fseek f 8 #seek_cur
							height = readBIGlong (readlong f #unsigned)
							fseek f 8 #seek_cur
							namelength = readBIGlong (readlong f #unsigned)
							textype =""
							for w=1 to namelength do (textype += (bit.intasChar(readByte f #unsigned)))
							fseek f 12 #seek_cur
							code105 = readBIGlong (readlong f #unsigned); if code105==105 then (fseek f 8 #seek_cur) else (fseek f -4 #seek_cur)
							fseek f 128	#seek_cur
							mipmapcount = (readBIGlong (readlong f #unsigned)) +1
							fseek f 20 #seek_cur
							namelength = readBIGlong (readlong f #unsigned)
							texname = ""
							for w=1 to namelength  do (texname += (bit.intasChar(readByte f #unsigned)))
							texname = substring texname 1 (texname.count-4)
							fseek f 43 #seek_cur
							texsize = (readBIGlong (readlong f #unsigned))-4
							fseek f 4 #seek_cur
							texdata = #(texsize)
							for i = 1 to texsize do texdata[i]= (readbyte f #unsigned)
							print ("Converting texture: "+texname+".dds, Size: "+width as string+"x"+height as string+" mipmaps: "+mipmapcount as string)
							
							--write texture
							--DDS header stuff
							DDSD_CAPS =			0x00000001
							DDSD_HEIGHT =		0x00000002
							DDSD_WIDTH =		0x00000004
							DDSD_PITCH =		0x00000008
							DDSD_PIXELFORMAT =	0x00001000
							DDSD_MIPMAPCOUNT =	0x00020000
							DDSD_MIPMAPCOUNT =	0x00020000
							DDSD_LINEARSIZE =	0x00080000
							DDSD_DEPTH =		0x00800000
	
							DDPF_ALPHAPIXELS =	0x00000001
							DDPF_FOURCC =		0x00000004
							DDPF_RGB =			0x00000040
	
							DDSCAPS_COMPLEX= 	0x00000008
							DDSCAPS_TEXTURE =	0x00001000
							DDSCAPS_MIPMAP =	0x00400000
	
							DDSCAPS2_CUBEMAP =			0x00000200
							DDSCAPS2_CUBEMAP_POSITIVEX=	0x00000400
							DDSCAPS2_CUBEMAP_NEGATIVEX=	0x00000800
							DDSCAPS2_CUBEMAP_POSITIVEY=	0x00001000
							DDSCAPS2_CUBEMAP_NEGATIVEY=	0x00002000
							DDSCAPS2_CUBEMAP_POSITIVEZ=	0x00004000
							DDSCAPS2_CUBEMAP_NEGATIVEZ=	0x00008000
							DDSCAPS2_VOLUME =			0x00200000
	
							DXT1 = 0x31545844
							DXT2 = 0x32545844
							DXT3 = 0x33545844
							DXT4 = 0x34545844
							DXT5 = 0x35545844
	
							ddsd = #(18) --dds description
							ddpf = #(8) --dds pixel format
							ddsCaps = #(4) --dds caps
							
							--build dds header from data
							dwMagic = 0x20534444 --"DDS"
							ddsd[1] = 124
							ddsd[3] = height
							ddsd[4] = width
							ddsd[6] = 32
							ddsd[7] = mipmapcount
							for i = 8 to 18 do ddsd[i]=0
							ddpf[1] = 32
							ddpf[4] = 32
							ddpf[5] = 0x00ff0000
							ddpf[6] = 0x0000ff00
							ddpf[7] = 0x000000ff
							ddpf[8] = 0xff000000
							ddsCaps[1] = DDSCAPS_MIPMAP
							ddsCaps[2] = 0
							ddsCaps[3] = 0
							ddsCaps[4] = 0
							--case specific header stuff
							case textype of
							(
								"dxt1":( --working
									--print "Texture format is DXT1 " --DXT1
									ddsd[2] = bit.or (bit.or (bit.or(bit.or (bit.or DDSD_CAPS DDSD_HEIGHT) DDSD_WIDTH) DDSD_PIXELFORMAT) DDSD_MIPMAPCOUNT) DDSD_LINEARSIZE
									ddpf[3] = DXT1
									ddsd[5] = texsize
									ddpf[2] = DDPF_FOURCC
								)
								"dxt5":( --working
									--print "Texture format is DXT5" --DXT5
									ddsd[2] = bit.or (bit.or (bit.or(bit.or (bit.or DDSD_CAPS DDSD_HEIGHT) DDSD_WIDTH) DDSD_PIXELFORMAT) DDSD_MIPMAPCOUNT) DDSD_LINEARSIZE
									ddpf[3] = DXT5
									ddsd[5] = texsize
									ddpf[2] = DDPF_FOURCC
								)
							)
							--open output file
							fout = fopen (texname+".dds") "wb"
							--write header to file
							writelong fout dwMagic
							for i = 1 to 18 do (writeLong fout ddsd[i])
							for i = 1 to 8  do (writeLong fout ddpf[i])
							for i = 1 to 4  do (writeLong fout ddsCaps[i])
							writeLong fout 0
							--write texture data to file
							for i = 1 to texsize do (writeByte fout texdata[i] #unsigned)
							--flush output file
							fflush fout
							--close output file
							fclose fout
							if ftell f == filesize then exit
							)--code 83
							)--case
						) while (code1 == 83)or(code1==93)and(ftell f <filesize) 
						)--RENDERINTERFACEBOUND

						"PNSTRING":(
						print "Reading PNSTRING section"
						fseek f (size134-24) #seek_cur						
						) --PNSTRING

						"NEANIMATION":(
						print "Reading NEANIMATION section"
						fseek f (size134-27) #seek_cur
						) --NEANIMATION

						"NEANIMSET":(
						print "Reading NEANIMSET section"
						fseek f (size134-25) #seek_cur						
						) --NEANIMSET

						"NEANIMCHANNEL":(
						print "Reading NEANIMCHANNEL section"
						fseek f (size134-29) #seek_cur						
						) --NEANIMCHANNEL

						"NEANIMKEYDATABLOCK":(
						print "Reading NEANIMKEYDATABLOCK section"
						fseek f (size134-34) #seek_cur						
						) --NEANIMKEYDATABLOCK

						"SKELETON":(
						print "Reading SKELETON section"
						fseek f (size134-24) #seek_cur						
						) --SKELETON	

					)--196
				)--134
			)
		)
	)
	)while ((ftell f) < filesize)

	print matsarr
	print "File loaded!"

	fclose f
)





fn readBIGlong longnum = --reads a long from big endian
(
	longnum = bit.swapBytes longnum 1 4
	longnum = bit.swapBytes longnum 2 3
)

fn readBIGfloat longnum = --reads a float from big endian
(
	longnum = bit.swapBytes longnum 1 4
	longnum = bit.swapBytes longnum 2 3
	return bit.intAsFloat longnum 
)

fn readBIGshort shortnum = --reads a short from big endian
(
	shortnum = bit.swapBytes shortnum 1 2
)

fn readBIGhalf shortnum = --reads a half float from big endian
(
	x = bit.swapBytes shortnum 1 2
	along = x as integer
	nx = (bit.shift (bit.and along 0x8000) 16)+(bit.shift (bit.and along  0x7fff) 13)+(bit.shift (127 - 15) 23) 
	return bit.intAsFloat nx
)


fn applyuvw anode auvarray = --applies UVW to node
(
	if (auvarray.count > 0) then
	(
		anode.numtverts = anode.numverts
		buildtvfaces anode
		for vi = 1 to anode.numverts do
		(
			settvert anode vi auvarray[vi]
		)				
		allfaces = #()
		for fi = 1 to anode.numfaces do					
		(
			crtface = getface anode fi
			append allfaces crtface
		)
		for fi = 1 to anode.numfaces do
		(
			settvface anode fi allfaces[fi]
		)
	)
)